image: docker:20.10.3

variables:
  ECR_REGISTRY: "$AWS_ACCOUNT.dkr.ecr.$AWS_DEFAULT_REGION.amazonaws.com"
  IMAGE_NAME: "entity-service"
  E2E_TEST_BRANCH_NAME: "master"

# services:
#   - docker:20.10.3-dind

.deploy_base: &deploy_base
  stage: deploy-dev
  allow_failure: true
  # dependencies:
  #   - build
  script:
    - echo "DEPLOYED SUCCESSFULLY"
    - echo "$CHAT_CHANNEL"
    - echo "$CHAT_INPUT"
    - echo "$CI"
    - echo "$CI_API_V4_URL"
    - echo "$CI_BUILDS_DIR"
    - echo "$CI_COMMIT_BEFORE_SHA"
    - echo "$CI_COMMIT_BRANCH"
    - echo "$CI_COMMIT_DESCRIPTION"
    - echo "$CI_COMMIT_MESSAGE"
    - echo "$CI_COMMIT_REF_NAME"
    - echo "$CI_COMMIT_REF_PROTECTED"
    - echo "$CI_COMMIT_REF_SLUG"
    - echo "$CI_COMMIT_SHA"
    - echo "$CI_COMMIT_SHORT_SHA"
    - echo "$CI_COMMIT_TAG"
    - echo "$CI_COMMIT_TIMESTAMP"
    - echo "$CI_COMMIT_TITLE"
    - echo "$CI_CONCURRENT_ID"
    - echo "$CI_CONCURRENT_PROJECT_ID"
    - echo "$CI_CONFIG_PATH"
    - echo "$CI_DEBUG_TRACE"
    - echo "$CI_DEFAULT_BRANCH"
    - echo "$CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX"
    - echo "$CI_DEPENDENCY_PROXY_PASSWORD"
    - echo "$CI_DEPENDENCY_PROXY_SERVER"
    - echo "$CI_DEPENDENCY_PROXY_USER"
    - echo "$CI_DEPLOY_FREEZE"
    - echo "$CI_DEPLOY_PASSWORD"
    - echo "$CI_DEPLOY_USER"
    - echo "$CI_DISPOSABLE_ENVIRONMENT"
    - echo "$CI_ENVIRONMENT_NAME"
    - echo "$CI_ENVIRONMENT_SLUG"
    - echo "$CI_ENVIRONMENT_URL"
    - echo "$CI_ENVIRONMENT_ACTION"
    - echo "$CI_ENVIRONMENT_TIER"
    - echo "$CI_HAS_OPEN_REQUIREMENTS"
    - echo "$CI_JOB_ID"
    - echo "$CI_JOB_IMAGE"
    - echo "$CI_JOB_JWT"
    - echo "$CI_JOB_MANUAL"
    - echo "$CI_JOB_NAME"
    - echo "$CI_JOB_STAGE"
    - echo "$CI_JOB_STATUS"
    - echo "$CI_JOB_TOKEN"
    - echo "$CI_JOB_URL"
    - echo "$CI_JOB_STARTED_AT"
    - echo "$CI_KUBERNETES_ACTIVE"
    - echo "$CI_NODE_INDEX"
    - echo "$CI_NODE_TOTAL"
    - echo "$CI_OPEN_MERGE_REQUESTS"
    - echo "$CI_PAGES_DOMAIN"
    - echo "$CI_PAGES_URL"
    - echo "$CI_PIPELINE_ID"
    - echo "$CI_PIPELINE_IID"
    - echo "$CI_PIPELINE_SOURCE"
    - echo "$CI_PIPELINE_TRIGGERED"
    - echo "$CI_PIPELINE_URL"
    - echo "$CI_PIPELINE_CREATED_AT"
    - echo "$CI_PROJECT_CONFIG_PATH"
    - echo "$CI_PROJECT_DIR"
    - echo "$CI_PROJECT_ID"
    - echo "$CI_PROJECT_NAME"
    - echo "$CI_PROJECT_NAMESPACE"
    - echo "$CI_PROJECT_PATH_SLUG"
    - echo "$CI_PROJECT_PATH"
    - echo "$CI_PROJECT_REPOSITORY_LANGUAGES"
    - echo "$CI_PROJECT_ROOT_NAMESPACE"
    - echo "$CI_PROJECT_TITLE"
    - echo "$CI_PROJECT_URL"
    - echo "$CI_PROJECT_VISIBILITY"
    - echo "$CI_REGISTRY_IMAGE"
    - echo "$CI_REGISTRY_PASSWORD"
    - echo "$CI_REGISTRY_USER"
    - echo "$CI_REGISTRY"
    - echo "$CI_REPOSITORY_URL"
    - echo "$CI_RUNNER_DESCRIPTION"
    - echo "$CI_RUNNER_EXECUTABLE_ARCH"
    - echo "$CI_RUNNER_ID"
    - echo "$CI_RUNNER_REVISION"
    - echo "$CI_RUNNER_SHORT_TOKEN"
    - echo "$CI_RUNNER_TAGS"
    - echo "$CI_RUNNER_VERSION"
    - echo "$CI_SERVER_HOST"
    - echo "$CI_SERVER_NAME"
    - echo "$CI_SERVER_PORT"
    - echo "$CI_SERVER_PROTOCOL"
    - echo "$CI_SERVER_REVISION"
    - echo "$CI_SERVER_URL"
    - echo "$CI_SERVER_VERSION_MAJOR"
    - echo "$CI_SERVER_VERSION_MINOR"
    - echo "$CI_SERVER_VERSION_PATCH"
    - echo "$CI_SERVER_VERSION"
    - echo "$CI_SERVER"
    - echo "$CI_SHARED_ENVIRONMENT"
    - echo "$GITLAB_CI"
    - echo "$GITLAB_FEATURES"
    - echo "$GITLAB_USER_EMAIL"
    - echo "$GITLAB_USER_ID"
    - echo "$GITLAB_USER_LOGIN"
    - echo "$GITLAB_USER_NAME"
    - echo "$TRIGGER_PAYLOAD"
    - echo "JOJOJOJOJOJJOJOJOJOJOJOJOJOJOJOJOJOJOJOJOJOJOJOJOJOJO"
    - echo "夢みる太陽"
    # - exit 1
    - echo "主神期"
    - echo "バイナリメノポーズ"
  after_script:
    - echo "Hi ther!!!!"
    # - git name-rev $CI_COMMIT_SHA
  only:
    - tags
  when: manual

# .end_to_end_test_base: &end_to_end_test_base
#   stage: end_to_end_test
#   trigger:
#     project: aon/ips/quality-assurance/api-packages/entity-service
#     branch: ${E2E_TEST_BRANCH_NAME} 
#     # branch: ${CI_COMMIT_BRANCH} ${CI_MERGE_REQUEST_TARGET_BRANCH_NAME}
#     # branch_default: master    # I wish.... sad day
#     strategy: depend
#   #   # variables:
#   #   #   TAGS: "BVT"
#   #   #   JOB_LEVEL: $REGRESSIONS_JOB_LEVEL
#   #   #   CI_ENV: $REGRESSIONS_TARGET_ENV
#   # when: on_success    # I was thinking it might be good to have this here... so then it'd be required to click this before you can get to the end.... or maybe not? It'd probs have to be auto kicked-off perhaps?

.develop_env_base: &develop_env_base
  environment:
    name: develop
  only:
    refs:
      - tags
    variables:
      - $CI_COMMIT_TAG =~ /^\d+.\d+.\d+($|-.+?\.\d+$)/

.qa_env_base: &qa_env_base
  environment:
    name: qa
  only:
    refs:
      - tags
    variables:
      - $CI_COMMIT_TAG =~ /^\d+.\d+.\d+($|-(beta|alpha)\.\d+$)/

.prod_env_base: &prod_env_base
  environment:
    name: production
  only:
    refs:
      - tags
    variables:
      - $CI_COMMIT_TAG =~ /^\d+.\d+.\d+$/

stages:
  - deploy-dev
  - generate_e2e_test
  - run_e2e_test

deploy-dev:
  <<: *deploy_base
  <<: *develop_env_base
  after_script:
    - echo "GENERATING END TO END DEV TEST PIPELINE"
    - ./generate_e2e_config.sh "dev" "${E2E_TEST_BRANCH_NAME}"
    - ls
    - cat generated_e2e_pipeline_dev.yml
  artifacts:
    paths:
      - generated_e2e_pipeline_dev.yml

#deploy-qa:
#  <<: *deploy_base
#  <<: *qa_env_base
#
#deploy-prod:
#  <<: *deploy_base
#  <<: *prod_env_base

########################################################generate-e2e-dev:
########################################################  # <<: *end_to_end_test_base
########################################################  # <<: *develop_env_base
########################################################  stage: generate_e2e_test
########################################################  script:
########################################################    - ./generate_e2e_config.sh "dev" "${E2E_TEST_BRANCH_NAME}"
########################################################    - ls
########################################################    - cat generated_e2e_pipeline_dev.yml
########################################################  only:
########################################################    refs:
########################################################      - tags
########################################################    variables:
########################################################      - $CI_COMMIT_TAG =~ /^\d+.\d+.\d+($|-.+?\.\d+$)/
########################################################  needs:
########################################################    - job: deploy-dev
########################################################  artifacts:
########################################################    paths:
########################################################      - generated_e2e_pipeline_dev.yml
########################################################  when: manual

#generate-e2e-qa:
#  # <<: *end_to_end_test_base
#  # <<: *qa_env_base
#  stage: generate_e2e_test
#  script:
#    - ./generate_e2e_config.sh "test" "${E2E_TEST_BRANCH_NAME}"
#    - ls
#    - cat generated_e2e_pipeline_test.yml
#  only:
#    refs:
#      - tags
#    variables:
#      - $CI_COMMIT_TAG =~ /^\d+.\d+.\d+($|-(beta|alpha)\.\d+$)/
#  needs:
#    - job: deploy-qa
#  artifacts:
#    paths:
#      - generated_e2e_pipeline_test.yml
#  when: manual

trigger-e2e-dev:
  stage: deploy-dev #run_e2e_test
  trigger:
    include:
      - artifact: generated_e2e_pipeline_dev.yml
        job: deploy-dev #generate-e2e-dev
    strategy: depend
  only:
    refs:
      - tags
    variables:
      - $CI_COMMIT_TAG =~ /^\d+.\d+.\d+($|-.+?\.\d+$)/
  needs:
    - job: deploy-dev #generate-e2e-dev

#trigger-e2e-qa:
#  stage: run_e2e_test
#  trigger:
#    include:
#      - artifact: generated_e2e_pipeline_test.yml
#        job: generate-e2e-qa
#    strategy: depend
#  only:
#    refs:
#      - tags
#    variables:
#      - $CI_COMMIT_TAG =~ /^\d+.\d+.\d+($|-(beta|alpha)\.\d+$)/
#  needs:
#    - job: generate-e2e-qa
